poller/urls.py
#
# -*- coding: utf-8 -*- vim:fileencoding=utf-8:

# Copyright (C) 2010-2014 GRNET S.A.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
from django.conf.urls import url

from poller import views
urlpatterns = [
    #'poller.views',
    url('^$', views.main),
    # 1st call to get all existing messages
    url('^message/existing/(?P<peer_id>[\w\-]+)/$', views.message_existing, name='fetch-existing'),
    # update - get new messages
    url('^message/updates/(?P<peer_id>[\w\-]+)/$', views.message_updates, name='fetch-updates'),
    url('^message/updates/(?P<peer_id>[\w\-]+)/(?P<last_id>[\w\-]+)$', views.message_updates, name='fetch-updates')
]

accounts/models.py
# -*- coding: utf-8 -*- vim:fileencoding=utf-8:
# vim: tabstop=4:shiftwidth=4:softtabstop=4:expandtab

# Copyright (C) 2010-2014 GRNET S.A.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from django.db import models
from django.conf import settings
from django.contrib.auth.models import AbstractBaseUser, User, BaseUserManager
from peers.models import Peer


class UserProfile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    peers = models.ManyToManyField(Peer, related_name='user_profile')
    objects = BaseUserManager()
    USERNAME_FIELD = 'username'

    class Meta:
        permissions = (
            ("overview", "Can see registered users and rules"),
        )

    def username(self):
        return "%s" % (self.user.username)

    def __unicode__(self):
        return self.username()

    def get_address_space(self):
        networks = self.domain.networks.all()
        if not networks:
            return False
        return networks

    def is_delete_allowed(self):
        user_is_admin = self.user.is_superuser
        username = self.username
        return (user_is_admin and settings.ALLOW_DELETE_FULL_FOR_ADMIN) or settings.ALLOW_DELETE_FULL_FOR_USER_ALL or (username in settings.ALLOW_DELETE_FULL_FOR_USER_LIST)

peers/models.py
# -*- coding: utf-8 -*- vim:fileencoding=utf-8:
# vim: tabstop=4:shiftwidth=4:softtabstop=4:expandtab

# Copyright (C) 2010-2014 GRNET S.A.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from django.contrib.auth.models import User
from django.db import models
from utils.whois import *
from django.conf import settings


class PeerRange(models.Model):
    network = models.CharField(max_length=128)

    def __unicode__(self):
        return self.network
    def __str__(self):
        return self.__unicode__()

    class Meta:
        db_table = u'peer_range'
        ordering = ['network']
        managed = settings.PEER_RANGE_MANAGED_TABLE


class TechcEmail(models.Model):
    email = models.CharField(max_length=352, db_column="email")

    def __unicode__(self):
        return self.email
    def __str__(self):
        return self.__unicode__()

    class Meta:
        db_table = "techc_email"
        managed = settings.PEER_TECHC_MANAGED_TABLE


class Peer(models.Model):
    peer_id = models.AutoField(primary_key=True)
    peer_name = models.CharField(max_length=128)
    peer_as = models.IntegerField(null=True, blank=True)
    # This needs to be converted to slug and an info message needs to be added.
    peer_tag = models.CharField(max_length=64)
    domain_name = models.CharField(max_length=128, null=True, blank=True)
    networks = models.ManyToManyField(PeerRange, blank=True)
    techc_emails = models.ManyToManyField(TechcEmail, blank=True)

    def __unicode__(self):
        return self.peer_name
    def __str__(self):
        return self.__unicode__()

    class Meta:
        db_table = u'peer'
        ordering = ['peer_name']
        managed = settings.PEER_MANAGED_TABLE

    def fill_networks(self):
        network_range = []
        networks_list = []
        peer_as = "AS%s" % self.peer_as
        network_range = whois(peer_as)
        if network_range:
            for network_item in network_range:
                range, created = PeerRange.objects.get_or_create(network=network_item.compressed)
                networks_list.append(range)
            self.networks = networks_list
            self.save()


class PeerNotify(models.Model):
    peer = models.ForeignKey(Peer, on_delete=models.CASCADE)
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    peer_activation_notified = models.BooleanField(default=True)

templates/django_registration/activate.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{% trans "Activation Status" %}{% endblock %}
   {% block sidenav %}{% endblock %}
   {% block extraheadbottom %}
<style>
	@media (min-width: 768px) {
		#page-wrapper {
		    border-left: none;
		    margin: 0;
		}
}
</style>
{% endblock %}

{% block contentplaceholder %}
       <div class="container">
       <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">{% trans "Activation Status" %}</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="row">
                <div class="col-lg-12">
                	<div class="panel panel-primary">
                        <div class="panel-heading">
                            <i class="fa fa-info-circle"></i> Activation Status
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            {% if error and account %}<div class="alert alert-info">{{error}}</div>{% endif %}
                            <div class="alert {% if account %}alert-success{% else %}alert-info{% endif %}">
                      					{% if account %}
                      					    {{account}} {% trans "succesfully activated" %}
                      					{% elif error %}
                                            {{error}}
                      					{% else %}
                      					    {% trans "The user has probably been already activated." %}
                      					{% endif %}
                        	</div>
                        </div>
                       </div>
                      </div>
                     </div>
				</div>
	{% endblock %}

templates/django_registration/activate_edit.html
{% extends "base.html" %}
{% load staticfiles %}
{% load widget_tweaks %}

{% load i18n %}
   {% block sidenav %}{% endblock %}
   {% block extraheadbottom %}
<style>
	@media (min-width: 768px) {
		#page-wrapper {
		    border-left: none;
		    margin: 0;
		}
}
</style>
<link href="{% static 'js/select2/select2.css' %}" rel="stylesheet">
<link href="{% static 'js/select2/select2-bootstrap.css' %}" rel="stylesheet">
{% endblock %}

       {% block contentplaceholder %}
       <div class="container">
       <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">{% trans "Activate User" %}</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="row">
                <div class="col-lg-12">
                	<div class="panel panel-primary">
                        <div class="panel-heading">
                            <i class="fa fa-user"></i> {% trans "Activate User" %}
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
						<form method="POST" class="form-horizontal">
							{% csrf_token %} {% if form.non_field_errors %}
							<p class="error">{{ form.non_field_errors}}</p>
							{% endif %}
							<div class="form-group {% if form.user.errors %} has-error {% endif %}">
								<label class="col-md-2 control-label" for="id_peer"><b>{% trans "User" %}</b></label>
								<div class="col-md-8">
		            				{% render_field form.user class+="form-control"  %}
		            				{% if form.user.errors %} <span class="help-block"> {{ form.user.errors|join:", " }} </span>
		           					 {% endif %}
		       					 </div>
							</div>
							<div class="form-group {% if form.peers.errors %} has-error {% endif %}">
								<label class="col-md-2 control-label" for="id_peer"><b>{% trans "Institution" %}</b></label>
								<div class="col-md-8">
		            				{% render_field form.peers class+="form-control"  %}
		            				{% if form.peers.errors %} <span class="help-block"> {{ form.peers.errors|join:", " }} </span>
		           					 {% endif %}
		       					 </div>
							</div>

							<div class="form-group">
				 	<div class="col-md-2"></div>
				 	 	<div class="col-md-8">
							<button type="submit" id="applybutton" value="{% trans 'Apply' %}" class="btn btn-md btn-primary">{% trans "Activate" %}</button>
						</div>
					</div>

            	</div>
        	</div>
    	</div>
	</div>
</div>

	{% endblock %}

{% block pagejsbottom %}
	<script type="text/javascript" src="{% static 'js/select2/select2.js' %}"></script>
	<script>
		$(document).ready( function(){
			$('#id_peers').select2();
		});
	</script>
{% endblock %}

templates/django_registration/activation_complete.html
{% extends "base.html" %}

{% load i18n %}
{% block title %}{% trans "Activation Complete" %}{% endblock %}
   {% block sidenav %}{% endblock %}
   {% block extraheadbottom %}
<style>
	@media (min-width: 768px) {
		#page-wrapper {
		    border-left: none;
		    margin: 0;
		}
}
</style>
{% endblock %}

{% block contentplaceholder %}
       <div class="container">
       <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">{% trans "Activation Complete" %}</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="row">
                <div class="col-lg-12">
                	<div class="panel panel-primary">
                        <div class="panel-heading">
                            <i class="fa fa-info-circle"></i> Activation Status
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                        						{% trans "The user will be notified about his/her account activation" %}
                        </div>
                       </div>
                      </div>
                     </div>
				</div>
	{% endblock %}

templates/django_registration/activation_failed.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{% trans "Activation Status" %}{% endblock %}
   {% block sidenav %}{% endblock %}
   {% block extraheadbottom %}
<style>
	@media (min-width: 768px) {
		#page-wrapper {
		    border-left: none;
		    margin: 0;
		}
}
</style>
{% endblock %}

{% block contentplaceholder %}
       <div class="container">
       <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">{% trans "Activation Status" %}</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="row">
                <div class="col-lg-12">
                	<div class="panel panel-primary">
                        <div class="panel-heading">
                            <i class="fa fa-info-circle"></i> Activation Status
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                          <div class="alert {% if account %}alert-success{% else %}alert-info{% endif %}">
                            {% if activation_error %}{{activation_error.message}}{% else %}Unknown error{% endif %}
                          </div>
                        </div>
                       </div>
                      </div>
                     </div>
				</div>
	{% endblock %}

templates/django_registration/login.html
{% extends "base.html" %}
{% load staticfiles %}
{% load widget_tweaks %}

{% load i18n %}
   {% block sidenav %}{% endblock %}
   {% block extraheadbottom %}
<style>
	@media (min-width: 768px) {
		#page-wrapper {
		    border-left: none;
		    margin: 0;
		}
}
</style>
<link href="{% static 'js/select2/select2.css' %}" rel="stylesheet">
<link href="{% static 'js/select2/select2-bootstrap.css' %}" rel="stylesheet">
{% endblock %}

       {% block contentplaceholder %}
       <div class="container">
       <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Select Institution</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="row">
                <div class="col-lg-12">
                	<div class="panel panel-primary">
                        <div class="panel-heading">
                            <i class="fa fa-building-o"></i> Select Institution
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">

                        	<div class="alert alert-info">Excellent! You are a step away from joining the service. Select your institution from the dropdown list.</div>
						<form method="POST" class="form-horizontal"	action="{% url 'selectinst' %}">
							{% csrf_token %} {% if form.non_field_errors %}
							<p class="error">{{ form.non_field_errors}}</p>
							{% endif %}
							<div style="display: none">{{form.user}}</div>
							<div class="form-group {% if form.peers.errors %} has-error {% endif %}">
								<label class="col-md-2 control-label" for="id_peer"><b>{% trans "Institution" %}</b></label>
								<div class="col-md-8">
		            				{% render_field form.peers class+="form-control"  %}
		            				{% if form.peers.errors %} <span class="help-block"> {{ form.peers.errors|join:", " }} </span>
		           					 {% endif %}
		       					 </div>
							</div>

							<div class="form-group">
			 	<div class="col-md-2"></div>
			 	 <div class="col-md-8">
			<button type="submit" id="applybutton" value="{% trans 'Apply' %}" class="btn btn-md btn-primary">Apply</button>
				</div>
			</div>

            			</div>
            			</div>
            			</div>
            			</div>
</div>

	{% endblock %}




{% block pagejsbottom %}
	<script type="text/javascript" src="{% static 'js/select2/select2.js' %}"></script>
	<script>
		$(document).ready( function(){
			$('#id_peers').select2();
		});
	</script>
{% endblock %}

templates/django_registration/select_institution.html
{% extends "base.html" %}
{% load staticfiles %}
{% load widget_tweaks %}

{% load i18n %}
   {% block sidenav %}{% endblock %}
   {% block extraheadbottom %}
<style>
	@media (min-width: 768px) {
		#page-wrapper {
		    border-left: none;
		    margin: 0;
		}
}
</style>
<link href="{% static 'js/select2/select2.css' %}" rel="stylesheet">
<link href="{% static 'js/select2/select2-bootstrap.css' %}" rel="stylesheet">
{% endblock %}

       {% block contentplaceholder %}
       <div class="container">
       <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Select Institution</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="row">
                <div class="col-lg-12">
                	<div class="panel panel-primary">
                        <div class="panel-heading">
                            <i class="fa fa-building-o"></i> Select Institution
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">

                        	<div class="alert alert-info">Excellent! You are a step away from joining the service. Select your institution from the dropdown list.</div>
						<form method="POST" class="form-horizontal"	action="{% url 'selectinst' %}">
							{% csrf_token %} {% if form.non_field_errors %}
							<p class="error">{{ form.non_field_errors}}</p>
							{% endif %}
							<div style="display: none">{{form.user}}</div>
							<div class="form-group {% if form.peers.errors %} has-error {% endif %}">
								<label class="col-md-2 control-label" for="id_peer"><b>{% trans "Institution" %}</b></label>
								<div class="col-md-8">
		            				{% render_field form.peers class+="form-control"  %}
		            				{% if form.peers.errors %} <span class="help-block"> {{ form.peers.errors|join:", " }} </span>
		           					 {% endif %}
		       					 </div>
							</div>

							<div class="form-group">
			 	<div class="col-md-2"></div>
			 	 <div class="col-md-8">
			<button type="submit" id="applybutton" value="{% trans 'Apply' %}" class="btn btn-md btn-primary">Apply</button>
				</div>
			</div>

            			</div>
            			</div>
            			</div>
            			</div>
</div>

	{% endblock %}




{% block pagejsbottom %}
	<script type="text/javascript" src="{% static 'js/select2/select2.js' %}"></script>
	<script>
		$(document).ready( function(){
			$('#id_peers').select2();
		});
	</script>
{% endblock %}